<template>
    <div class="examination">
     <el-dialog @close="closeDialog" :visible.sync="dialogTableVisible" customClass="customWidth_syst">
        <div slot="title" class="titleBox">
        <i :class="tableType === 0? 'el-icon-document':'el-icon-edit-outline'" style="font-size: 20px"></i>
        <!-- <img style="width: 25px; height: 25px" src='../../../../assets/img/imgScreen/more.png' /> -->
        <span style="margin-left:10px;font-size:18px">{{tableTypeDsc}}</span>
        </div>
       <el-form ref="baseData" label-width="90px" :rules="ruleValidate" :model="baseData">
         <el-row>
          <el-col :span="10">
            <el-form-item prop="objTypeName" label="异常类型">
              <el-input v-model="baseData.objTypeName" readonly disabled size="small"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="10">
            <el-form-item prop="matName" label="物料名称">
              <el-input v-model="baseData.matName" readonly disabled size="small"></el-input>
            </el-form-item>
          </el-col>
          </el-row>
          <el-row>
            <el-col :span="10">
            <el-form-item prop="prcResultName" label="处理结果">
             <el-select v-model="prcResultNameTypeIndex" filterable collapse-tags size="small">
                <el-option v-for="(item,index) in prcResultNameType" :key="index" :label="item.baseName" :value="index">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <!-- <el-col :span="10">
            <el-form-item prop="matClassName" label="缺陷类型">
              <el-select v-model="matClassNameTypeIndex" filterable collapse-tags size="small" @change="selectTrigger(matClassNameTypeIndex)">
                <el-option v-for="(item,index) in matClassNameType" :key="index" :label="item.matClassName" :value="index">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col> -->
           <el-col :span="10">
            <el-form-item prop="bugQty" label="缺陷数量">
              <el-input v-model="baseData.bugQty" size="small"></el-input>
            </el-form-item>
          </el-col>
          <!-- <el-col :span="10">
            <el-form-item prop="matName" label="异常单位">
             <el-select v-model="matNameTypeIndex" filterable collapse-tags size="small">
                <el-option v-for="(item,index) in matNameType" :key="index" :label="item.matName" :value="index">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col> -->
         </el-row>
          <el-row>
             <el-col :span="10">
            <el-form-item prop="bugWgt" label="缺陷重量（t）">
              <el-input v-model="baseData.bugWgt" size="small"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="10">
            <el-form-item prop="outPkt" label="赔偿金额">
              <el-input v-model="baseData.outPkt" size="small"></el-input>
            </el-form-item>
          </el-col>
         </el-row>
         <el-row>
          <el-col :span="10">
            <el-form-item prop="lostWgt" label="退货">
              <el-input v-model="baseData.lostWgt" size="small"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="10">
            <el-form-item prop="cutPrice" label="降价">
              <el-input v-model="baseData.cutPrice" size="small"></el-input>
            </el-form-item>
          </el-col>
         </el-row>
       </el-form>
       <span slot="footer" class="dialog-footer">
        <el-button type="goon" size="mini" icon="el-icon-check" @click="tableType === 0 ? addData():modifyData()">确定</el-button>
        <el-button size="mini" type="goon" icon="el-icon-remove-outline" @click="cancel">取消</el-button>
      </span>
    </el-dialog>
    </div>
</template>
<script>
import {
  getCookie
} from '@/utils/util.js';
import {
  cookieUserId,
  cookieUserName
} from '@/config/config.js';
let userName = getCookie(cookieUserName);
let userId = getCookie(cookieUserId);
export default {
  props: ['showFlag2', 'Params', 'Params2'],
    data () {
        return {
            dialogTableVisible: false,
            tableTypeDsc: '新增异常处理明细信息',
            tableType: 0,
            seen: true,
            seenNo: true,
            beInvalid: false,
            prcResultNameTypeIndex: 0,
            prcResultNameType: [],
            tableData: [],
            baseData: {
              objTypeName: '',
              matName: '',
              memo: '',
              bugQty: '',
              bugWgt: '',
              outPkt: '',
              lostWgt: '',
              cutPrice: '',
            },
            ruleValidate: {
              lostWgt: [{
               validator: this.lostWgtEmpty,
               trigger: 'change'
              }],
              cutPrice: [{
               validator: this.cutPriceEmpty,
               trigger: 'change'
              }]
              //matName: [{ required: true, message: '该项不能为空', trigger: 'change' }],
              //objTypeName: [{ required: true, message: '该项不能为空', trigger: 'change' }],
              // matName: [{ required: true, message: '该项不能为空', trigger: 'change' }]
             }
        }
    },
    mounted () {
      // this.getMatClassNameList (),
      this.getprcResultName ()
    },
    methods: {
      cancel () {
        let _this = this;
        _this.tableData = [];
        _this.prcResultNameTypeIndex = 0,
        _this.baseData = {
              objTypeName: '',
              matName: '',
              memo: '',
              bugQty: '',
              bugWgt: '',
              outPkt: '',
              lostWgt: '',
              cutPrice: '',
        }
        _this.dialogTableVisible = false
        _this.$emit('refresh')
      },
      lostWgtEmpty (rule, value, callback) {
         const age= /^[1-9]\d*\,\d*|[1-9]\d*$/
        if (this.prcResultNameTypeIndex === 0 && (this.baseData.lostWgt === '' || this.baseData.lostWgt === null)) {
          return callback(new Error('该项不能为空'))
        } else if (this.baseData.lostWgt) {
            if (!age.test(this.baseData.lostWgt)) {
             return callback(new Error('请输入数字！'))
             } else {
               return callback()
             }
        }else {
          return callback()
        }
      },
      cutPriceEmpty (rule, value, callback) {
         const age= /^[1-9]\d*\,\d*|[1-9]\d*$/
        if (this.prcResultNameTypeIndex === 1 && (this.baseData.cutPrice === '' || this.baseData.cutPrice === null)) {
          return callback(new Error('该项不能为空'))
        } else if (this.baseData.cutPrice) {
            if (!age.test(this.baseData.cutPrice)) {
             return callback(new Error('请输入数字！'))
             } else {
               return callback()
             }
        }else {
          return callback()
        }
      },
      addData () {
        let _this = this;
         _this.tableData = [];
         _this.$refs['baseData'].validate((valid) => {
          if (valid) {
             _this.dialogTableVisible = false;
             _this.baseData.createMan = userName;
             _this.baseData.createNo = userId;
             _this.baseData.prcResultCode = _this.prcResultNameType[_this.prcResultNameTypeIndex].baseCode;
             _this.baseData.prcResultName = _this.prcResultNameType[_this.prcResultNameTypeIndex].baseName;
             _this.tableData.push(_this.baseData)
             _this.axios.post('pass/baseManagement/v1/limsobjhandles/', _this.tableData, {individualType: 'json'}).then(res => {
                if (res.succeed) {
                 this.$message.success('添加成功')
                 _this.$emit('refresh')
                } else {
                 this.$message.error(res.message)
                }
                }).catch(e => {
                 this.$message.error(e.message)
               })
         }
       })
      },
      modifyData () {
        let _this = this;
         _this.tableData = [];
        _this.$refs['baseData'].validate((valid) => {
        if (valid) {
        _this.dialogTableVisible = false;
        _this.baseData.updateMan = userName;
        _this.baseData.updateNo = userId;
        _this.baseData.prcResultCode = _this.prcResultNameType[_this.prcResultNameTypeIndex].baseCode;
        _this.baseData.prcResultName = _this.prcResultNameType[_this.prcResultNameTypeIndex].baseName;
        _this.tableData.push(_this.baseData)
        _this.axios.put('pass/baseManagement/v1/limsobjhandles/', _this.baseData, {individualType: 'json'}).then(res => {
           if (res.succeed) {
            this.$message.success('修改成功')
            _this.$emit('refresh')
           } else {
            this.$message.error(res.message)
           }
           }).catch(e => {
            this.$message.error(e.message)
          })
        }
        })
      },
      renderHeader (h) {
         return (
             <div style="cursor: pointer ;line-height:20px" onClick={() => this.addRow()}>
             <i class="el-icon-plus" style="font-size:20px; color:rgb(18, 52, 243)"></i>
             </div>
         )
      },
     closeDialog () {
       let _this = this;
       _this.tableData = [];
       _this.prcResultNameTypeIndex = 0,
       _this.baseData = {
              objTypeName: '',
              matName: '',
              memo: '',
              bugQty: '',
              bugWgt: '',
              outPkt: '',
              lostWgt: '',
              cutPrice: '',
        }
       _this.seen = true;
       _this.seenNo = true;
       _this.beInvalid = false;
       _this.$emit('refresh')
     },
     getprcResultName () {
        this.axios.post("pass/baseManagement/v1/limsbaseinfos/queryBaseInfoByBaseCode",{validFlag:1,baseCode:4828}, {individualType: 'json'}).then(res => {
              this.prcResultNameType = res.data
            }).catch(e => {
              // this.dataLoading = false;
            });
      },
      tableHeaderCellStyle () {
      return 'background-color: rgb(249,249,249) !important;color: rgb(73, 72, 72);border-bottom: 1px solid #DCDFE7;border-top:3px solid #3ac1ea;'
      }
    },
    watch: {
      showFlag2 (arg) {
        let _this = this;
        _this.dialogTableVisible = true;
        if (_this.Params2 !== null) {
          _this.baseData = _this.Params2;
          _this.tableType = 1;
          _this.tableTypeDsc = '修改异常处理明细信息';
          _this.seen = false;
          _this.beInvalid = true;
          for (let j = 0; j < _this.prcResultNameType.length; j++) {
          if (_this.prcResultNameType[j].baseName === _this.baseData.prcResultName) {
             _this.prcResultNameTypeIndex = j;
          }
          }
        } else {
          _this.tableType = 0;
          _this.seenNo = false;
          _this.baseData.objTypeName = _this.Params.objTypeName;
          _this.baseData.matName = _this.Params.matName;
          _this.baseData.matNo = _this.Params.matNo;
          _this.baseData.objTypeCode = _this.Params.objTypeCode;
          _this.baseData.objId = _this.Params.objId;
          _this.tableTypeDsc = '新增异常处理明细信息';
        }
      }
    }
}
</script>
<style lang="less">
.customWidth_syst{
  width: 600px !important
}
</style>